(defun c:REC2 (/ basePoint length width p1 p2 p3 p4 osmode)
  ;; Guarda el estado original de OSMODE y desactiva el snap temporalmente
  (setq osmode (getvar "OSMODE"))
  

  (setq basePoint (getpoint "\nSeleccione el punto de inicio del rectángulo: "))

  ;; Función para validar y obtener la distancia
  (defun getValidDist (prompt)
    (setq dist (getdist prompt))
    (while (<= dist 0)
      (princ "\nError: El valor debe ser mayor que cero.")
      (setq dist (getdist prompt))
    )
    dist
  )

  ;; Obtiene el largo y el ancho con validación
  (setq length (getValidDist "\nIngrese el largo del rectángulo: "))
  (setq width (getValidDist "\nIngrese el ancho del rectángulo: "))

  ;; Calcula los puntos del rectángulo basado en el punto base, largo y ancho
  (setq p1 basePoint)
  (setq p2 (list (+ (car basePoint) length) (cadr basePoint)))
  (setq p3 (list (+ (car basePoint) length) (+ (cadr basePoint) width)))
  (setq p4 (list (car basePoint) (+ (cadr basePoint) width)))

(setvar "OSMODE" 0)

  ;; Dibuja el rectángulo utilizando el comando POLYLINE
  (command "_.pline" p1 p2 p3 p4 "c")
  
  ;; Restaura la configuración original de OSMODE
  (setvar "OSMODE" osmode)
  (princ)
)

(princ "\nDrawRectangle cargado y actualizado. Use el comando 'DrawRectangle' para iniciar.")
(princ)

